declare const _default: import("vue").DefineComponent<{
    /**
     * Total count of items.
     */
    totalCount: {
        type: NumberConstructor;
        required: true;
    };
    /**
     * Page size
     */
    pageSize: {
        type: NumberConstructor;
        required: true;
    };
    /**
     * Current page
     */
    currentPage: {
        type: NumberConstructor;
        required: true;
    };
    /**
     * Max visible page
     */
    maxVisiblePage: {
        type: NumberConstructor;
        default: number;
    };
    /**
     * First page label
     */
    firstPageLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * Previous page label
     */
    previousPageLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * Next page label
     */
    nextPageLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * Last page label
     */
    lastPageLabel: {
        type: StringConstructor;
        default: string;
    };
}, unknown, unknown, {}, {
    /**
     * Count of pages
     *
     * @returns {number}
     */
    getPageCount(): number;
    /**
     * Visible page list
     *
     * @returns {*[]}
     */
    getVisiblePages(): number[];
    /**
     * Is page active, or not
     *
     * @param page
     * @returns {boolean}
     */
    isPageActive(page: any): boolean;
    /**
     * On page click
     */
    onPageClick(page: any): void;
    /**
     * Page range, example: 3 available page, current page 3, range is: [1, 3] (zero-based)
     *
     * @returns {{beginPage: number, endPage: number}}
     */
    getPageRange(): {
        beginPage: number;
        endPage: number;
    };
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, "pageChanged"[], "pageChanged", import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<{
    /**
     * Total count of items.
     */
    totalCount: {
        type: NumberConstructor;
        required: true;
    };
    /**
     * Page size
     */
    pageSize: {
        type: NumberConstructor;
        required: true;
    };
    /**
     * Current page
     */
    currentPage: {
        type: NumberConstructor;
        required: true;
    };
    /**
     * Max visible page
     */
    maxVisiblePage: {
        type: NumberConstructor;
        default: number;
    };
    /**
     * First page label
     */
    firstPageLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * Previous page label
     */
    previousPageLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * Next page label
     */
    nextPageLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * Last page label
     */
    lastPageLabel: {
        type: StringConstructor;
        default: string;
    };
}>> & {
    onPageChanged?: ((...args: any[]) => any) | undefined;
}, {
    maxVisiblePage: number;
    firstPageLabel: string;
    previousPageLabel: string;
    nextPageLabel: string;
    lastPageLabel: string;
}, {}>;
export default _default;
