import { Ref } from 'vue';
declare const _default: import("vue").DefineComponent<{
    /**
     * Value for v-model
     */
    modelValue: {
        type: (NumberConstructor | StringConstructor)[];
        default: null;
    };
    /**
     * Html id
     */
    id: {
        type: StringConstructor;
        required: true;
    };
    /**
     * Label for textarea
     */
    label: {
        type: StringConstructor;
        default: undefined;
    };
    /**
     * Attribute hint
     */
    hint: {
        type: StringConstructor;
        default: undefined;
    };
    /**
     * Enable or disable validator
     */
    validatorEnabled: {
        type: BooleanConstructor;
        default: boolean;
    };
}, {
    inputRef: Ref<HTMLInputElement | null>;
    validator: {
        onInvalid: (event: InputEvent) => void;
        getInvalidMessage: () => string | null;
        setCustomError: (data: string) => void;
    };
}, unknown, {}, {
    /**
     * Hint id is generated
     */
    getHintId(): string;
    /**
     * On input event
     *
     * @param event
     */
    onInput(event: InputEvent): void;
    /**
     * On invalid event
     *
     * @param event
     */
    onInvalid(event: InputEvent): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, "update:modelValue"[], "update:modelValue", import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<{
    /**
     * Value for v-model
     */
    modelValue: {
        type: (NumberConstructor | StringConstructor)[];
        default: null;
    };
    /**
     * Html id
     */
    id: {
        type: StringConstructor;
        required: true;
    };
    /**
     * Label for textarea
     */
    label: {
        type: StringConstructor;
        default: undefined;
    };
    /**
     * Attribute hint
     */
    hint: {
        type: StringConstructor;
        default: undefined;
    };
    /**
     * Enable or disable validator
     */
    validatorEnabled: {
        type: BooleanConstructor;
        default: boolean;
    };
}>> & {
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
}, {
    label: string;
    modelValue: string | number;
    hint: string;
    validatorEnabled: boolean;
}, {}>;
export default _default;
